import java.io.InputStream;
import java.applet.Applet;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.Properties;
import java.util.Date;
import COM.Sun.Japan.yjs.mwt.ScrollableCanvas;
import COM.Sun.Japan.yjs.mwt.MessageDialog;
// for WebLogic Net Driver
import xjava.sql.*; // java.sql ̑
import weblogic.common.T3Client;
import weblogic.db.xjdbc.*;

public class HelloJDBC2 extends Applet implements ActionListener {
    T3Client t3;
    Connection conn;
    PreparedStatement pstmt;
    List names;
    Button exec;
    ScrollableCanvas display;
    int nperson;

    public HelloJDBC2() {
        Label nameLabel;
        setFont(new Font("Helvetica", Font.PLAIN, 14));
        nameLabel = new Label("\u540D\u524D:");
        names = new List(6, true);
        exec = new Button("\u691C\u7D22");
        display = new ScrollableCanvas(380, 105);
        display.setSize(400, 200);
        display.setCanvasBackground(Color.white);
        // layout
        GridBagLayout gbl = new GridBagLayout();
        GridBagConstraints gbc = new GridBagConstraints();
        setLayout(gbl);
        gbc.anchor = GridBagConstraints.NORTHWEST;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.gridheight = 1;
        gbc.gridwidth = GridBagConstraints.REMAINDER;
        gbc.insets = new Insets(15, 25, 0, 25);
        gbl.setConstraints(nameLabel, gbc);
        add(nameLabel);
        gbc.weightx = 1.0;
        gbc.weighty = 1.0;
        gbc.gridwidth = 2;
        gbc.fill = GridBagConstraints.BOTH;
        gbc.insets = new Insets(0, 25, 5, 5);
        gbl.setConstraints(names, gbc);
        add(names);
        gbc.anchor = GridBagConstraints.CENTER;
        gbc.gridwidth = GridBagConstraints.REMAINDER;
        gbc.insets = new Insets(5, 35, 5, 25);
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbl.setConstraints(exec, gbc);
        add(exec);
        gbc.fill = GridBagConstraints.BOTH;
        gbc.insets = new Insets(5, 25, 15, 25);
        gbc.gridwidth = 3;
        gbl.setConstraints(display, gbc);
        add(display);
        //
        setSize(400, 400);
        doLayout();
        exec.addActionListener(this);
    }

    public void init() {
        try {
            t3 = new T3Client("t3://javaemon:7001");
            t3.connect();
            Properties props = new Properties();
            props.put("user", "hellouser");
            props.put("password", "hellopwd");
            props.put("server", "JAVAEMON");
            props.put("weblogic.t3", t3);
            props.put("weblogic.t3.driver", "weblogic.jdbc.dblib.Driver");
            props.put("weblogic.t3.url", "jdbc:weblogic:sybase");
            
            Class.forName("weblogic.jdbc.t3client.Driver");
            conn = DriverManager.getConnection("jdbc:weblogic:t3client", props);
            pstmt = conn.prepareStatement("SELECT * FROM hello WHERE name = ?");
        } catch (Exception ex) {
            Container c;
            for (c = getParent(); c != null && !(c instanceof Frame); c = c.getParent());
            if (c != null)
                new MessageDialog("ERROR: Could not open DB connection.",
                                  ex, (Frame)c);
            setEnabled(false);
            return;
        }

        Statement stmt;
        ResultSet rs;
        String name;
        try {
            stmt = conn.createStatement();
            rs = stmt.executeQuery("SELECT name FROM hello");
            while (rs.next()) {
                name = rs.getString("name");
                names.add(name);
            }
        } catch (SQLException ex) {
            Container c;
            for (c = getParent(); c != null && !(c instanceof Frame); c = c.getParent());
            if (c != null)
                new MessageDialog("ERROR: Could not retrieve data.",
                                  ex, (Frame)c);
            setEnabled(false);
            return;
        }
    }

    public void destroy() {
        try {
            if (conn != null)
                conn.close();
            if (t3 != null)
                t3.disconnect();
        } catch (Exception ex) {}
    }

    /**
     * {^ exec ̃ANVECxg̃nhOsB
     */
    public void actionPerformed(ActionEvent ev) {
        String[] items;
        int i;

        nperson = 0;
        items = names.getSelectedItems();
        display.setScreenSize(display.getScreenSize().width,
                              items.length * 105 +10);
        for (i = 0; i < items.length; i++) {
            displayPersonalData(items[i]);
        }
    }

    /**
     * l̖OɂƂAf[^x[X̌sAʂ\B
     */
    void displayPersonalData(String name) {
        if (nperson == 0) {
            display.clearCanvas();
        }
        ResultSet rs;
        Graphics g = display.getGraphics();
        Image face;
        int age;
        Date birth_date;
        String comment;
        MediaTracker faceTracker = new MediaTracker(display);
        InputStream faceStrm;
        byte[] faceData = new byte[8192];
        Color txtC = new Color(190, 20, 225);
        Font txtF = new Font("Dialog", Font.PLAIN, 12);
        Font defF = getFont();
        Toolkit tk = Toolkit.getDefaultToolkit();
        try {
            pstmt.setString(1, name);
            rs = pstmt.executeQuery();
            while (rs.next()) {
                age = rs.getInt("age");
                birth_date = rs.getDate("birth_date");
                comment = rs.getString("comment");
                faceStrm = rs.getBinaryStream("face");
                if (faceStrm != null) {
                    faceStrm.read(faceData);
                    face = tk.createImage(new sun.awt.image.ByteArrayImageSource(faceData));
                    faceTracker.addImage(face, nperson);
                    faceTracker.waitForID(nperson);
                    g.drawImage(face, 5, 5 + nperson * 105, display);
                } else {
                    g.setColor(Color.black);
                    g.fillRect(5, 5 + nperson * 105, 80, 100);
                    g.setColor(txtC);
                    g.setFont(txtF);
                    g.drawString("No Image", 15, 61 + nperson * 105);
                }
                g.setFont(defF);
                g.setColor(txtC);
                g.drawString("\u540D\u524D: " + name, 120, 30 + nperson * 105);
                g.drawString("\u5E74\u9F62: " + age, 120, 50 + nperson * 105);
                g.drawString("\u751F\u5E74\u6708\u65E5: " + birth_date, 120, 70 + nperson * 105);
                g.drawString("\u30B3\u30E1\u30F3\u30C8: " + comment, 120, 90 + nperson * 105);
            }
        } catch (Exception ex) {
            Container c;
            for (c = getParent(); c != null && !(c instanceof Frame); c = c.getParent());
            if (c != null)
                new MessageDialog("ERROR: Could not retrieve data.",
                                  ex, (Frame)c);
        }
        nperson++;
    }
}
