/*
 * Copyright (c) 1996 Nihon Sun Microsystems K.K.
 *
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

import java.awt.event.*;

/**
 * ImageStore ̃ANVEXi
 * @author Yuichi Omata, Nihon Sun Microsystems K.K.
 * @version 1.1 97/01/21
 */
public class ImageStoreCommand implements ActionListener {

    static final int Connect = 0;
    static final int Quit = 1;
    static final int Select = 2;
    static final int Exec = 3;
    static final int Load = 4;

    int id;
    ImageStore imageStore;

    ImageStoreCommand(int id, ImageStore imageStore) {
	this.id = id;
	this.imageStore = imageStore;
    }

    public void actionPerformed(ActionEvent ev){
	switch (id){
        case Connect:
            imageStore.connect();
            break;
        case Quit:
            imageStore.quit();
            break;
        case Select:
            imageStore.modeSelect();
            break;
	case Exec:
            imageStore.exec(ev.getActionCommand());
            break;
	case Load:
	    imageStore.loadImage();
            break;
	}
    }
}
