/*
 * Copyright (c) 1996 Nihon Sun Microsystems K.K.
 *
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowEvent;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLWarning;
import java.sql.SQLException;
import COM.Sun.Japan.yjs.mwt.MessageDialog;
/**
 *  Login Prompt
 *
 * @version     1.2 97/01/11
 * @author      K.Tanaka
 */
public class Login extends Dialog implements ActionListener {
    /**
     * f[^x[XERlNVB
     */
    Connection conn;

    /**
     * et[B
     */
    Frame parent;

    /**
     * f[^x[XڑɕKvȃf[^͂tB[hQB
     */
    TextField url;
    TextField username;
    TextField password;

    /**
     * ok {^B
     */
    Button ok;

    /**
     * cancel {^B
     */
    Button cancel;

    /**
     * et[ɎRXgN^B
     * @param pr et[
     */
    public Login(Frame pr) {
	this(pr, true);
    }

    /**
     * et[ƃ[_̃tOɎRXgN^B
     * @param pr et[
     * @param mf [_̃tO
     */
    public Login(Frame pr, boolean mf) {
        super(pr, "Database Login", mf);
        setResizable(false);
        parent = pr;

        GridBagLayout gbl = new GridBagLayout();
        GridBagConstraints gbc = new GridBagConstraints();
        setFont(new Font("Helvetica", Font.PLAIN, 14));
        setLayout(gbl);

        Label lurl, lusername, lpassword;
        Insets il, it, ib;
        lurl = new Label("URL:", Label.RIGHT);
        url = new TextField(20);
        lusername = new Label("User Name:", Label.RIGHT);
        username = new TextField(20);
        lpassword = new Label("Password:", Label.RIGHT);
        password = new TextField(20);
        password.setEchoCharacter('*');
        ok = new Button("OK");
        cancel = new Button("Cancel");
        // layout
        il = new Insets(5, 5, 5, 2);
        it = new Insets(5, 2, 5, 5);
        ib = new Insets(5, 5, 5, 5);
        gbc.weightx = 0.0;
        gbc.weighty = 0.0;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.gridx = 0;
        gbc.gridy = 0;
        gbc.gridwidth = 1;
        gbc.anchor = GridBagConstraints.EAST;
        gbc.insets = il;
        gbl.setConstraints(lurl, gbc);
        add(lurl);
        gbc.gridy = 1;
        gbl.setConstraints(lusername, gbc);
        add(lusername);
        gbc.gridy = 2;
        gbl.setConstraints(lpassword, gbc);
        add(lpassword);
        gbc.gridx = 1;
        gbc.gridy = 0;
        gbc.gridwidth = 3;
        gbc.anchor = GridBagConstraints.WEST;
        gbc.insets = it;
        gbl.setConstraints(url, gbc);
        add(url);
        gbc.gridy = 1;
        gbl.setConstraints(username, gbc);
        add(username);
        gbc.gridy = 2;
        gbl.setConstraints(password, gbc);
        add(password);
        gbc.gridy = 3;
        gbc.fill = GridBagConstraints.NONE;
        gbc.gridwidth = 1;
        gbc.anchor = GridBagConstraints.EAST;
        gbc.insets = ib;
        gbl.setConstraints(ok, gbc);
        add(ok);
        gbc.gridx = 2;
        gbc.anchor = GridBagConstraints.WEST;
        gbl.setConstraints(cancel, gbc);
        add(cancel);

        pack();
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
        setSize(getSize().width + 20, getSize().height + 20);
        ok.addActionListener(this);
        cancel.addActionListener(this);
        show();
    }

    /**
     * f[^x[Xւ̐ڑsB
     */
    void connectDatabase() {
        try{
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
            conn = DriverManager.getConnection(url.getText(), username.getText(), password.getText());
            SQLWarning warn = conn.getWarnings();
            while(warn != null) {
                new MessageDialog("SQLWarning:" + warn.getMessage(), warn, parent);
                warn = warn.getNextWarning();
            }
            dispose();
	} catch (ClassNotFoundException ex) {
            new MessageDialog(ex, parent);
	} catch (SQLException ex) {
            while(ex != null) {
                new MessageDialog(ex, parent);
                ex = ex.getNextException();
            }
	}
    }

    /**
     * f[^x[Xւ̃RlNVԂB
     */
    public Connection getConnection() {
	return conn;
    }

    /**
     * ok {^ cancel {^Ŕ action performed Cxg
     * nhOB
     * @param ev CxgB
     */
    public void actionPerformed(ActionEvent ev) {
        if (ev.getSource() == ok) {
            connectDatabase();
            dispose();
        } else if (ev.getSource() == cancel) {
            dispose();
        }
    }

    /**
     * window Cxg̏B
     * @param ev CxgB
     */
    protected void processWindowEvent(WindowEvent ev) {
        if (ev.getId() == WindowEvent.WINDOW_CLOSING) {
            dispose();
        }
        super.processWindowEvent(ev);
    }
}
