/*
 * Copyright (c) 1996 Nihon Sun Microsystems K.K.
 *
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

import java.awt.Image;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.Toolkit;

/**
 * f[^x[X̃e[uɑΉf[^x[XEIuWFNgB
 *
 * @version     %I% %E%
 * @author      Tadayoshi Maekawa, Nihon Sun Microsystems K.K.
 */
public class TableObject extends DatabaseObject {
    public static final int UNDEFINED = 0;
    public static final int USERTABLE = 1;
    public static final int SYSTEMTABLE = 2;

    /**
     * TableObject ̃C[WBDatabaseObject.objectImage 
     * eIɂ͓AǍ݌邽߂ɁAimage
     * ێpƂĒǉB
     */
    static Image tableImage = null;

    /**
     * e[ũ^Cv\킷B
     */
    int tableType;

    /**
     * ftHgERXgN^B
     */
    public TableObject() {
        this(null, UNDEFINED);
    }

    /**
     * ̂ƃe[uE^CvɎRXgN^B
     * @param name e[u̖OB
     * @param type e[uE^CvB
     */
    public TableObject(String name, int type) {
        super(name);
        tableType = type;
    }

    /**
     * VXeEe[uۂB
     * @return VXeEe[uȂ trueB
     */
    public boolean isSystemTable() {
        return (tableType == SYSTEMTABLE) ? true : false;
    }

    /**
     * [UEe[uۂB
     * @return [UEe[uȂ trueB
     */
    public boolean isUserTable() {
        return (tableType == USERTABLE) ? true : false;
    }

    /**
     * eݒlZbgB
     * @param name e[ú̖B
     * @param x IuWFNg̈ʒu x WB
     * @param y IuWFNg̈ʒu y WB 
     * @param type e[ũ^CvB
     */
    public void setValues(String name, int x, int y, int type) {
        this.name = name;
        location.x = x;
        location.y = y;
        tableType = type;
    }

    /**
     * ̒lŎʒuAIuWFNgォۂ𔻒肷B
     * @param x x WB
     * @param y y WB
     */
    public boolean onObject(int x, int y) {
        return (x >= location.x && x <= (location.x + dimension.width) &&
                y >= location.y && y <= (location.y + dimension.height));
    }

    /**
     * IuWFNg̃ACRpC[WǍށB
     */
    protected void generateObjectImage() {
        objectImage = (tableImage != null) ? tableImage : Toolkit.getDefaultToolkit().getImage("images/table.gif");
        dimension.width = 95;
        dimension.height = 100;
        tableImage = objectImage;
    }
}
