/*
 * Copyright (c) 1996 Nihon Sun Microsystems K.K.
 *
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

import java.sql.*;
import java.util.*;
import COM.Sun.Japan.yjs.mwt.*;

/**
 * JDBCTerminal CEt[EW[
 * @version	%I% %E%
 * @author 	Yuichi Omata, Nihon Sun Microsystems K.K.
 */
public class MainFrame {
    JDBCTerminal app;
    MainFrameGUI gui;
    MainFrameCommand command;
    LoginDialog loginDialog;

    Connection conn;

    /**
     *
     */
    public MainFrame(JDBCTerminal app){
	this.app = app;
	(gui = new MainFrameGUI(this)).setVisible(true);
	updateDriverList();
	loginDialog = new LoginDialog(gui);
    }

    /**
     *
     * @return
     */
    public JDBCTerminal getApp(){
	return app;
    }

    /**
     * hCoEXgXVB
     */
    public void updateDriverList(){
	gui.driverList.removeAll();
	
        // hCoE}l[Wɓo^ĂhCo GUI ɕ\
	for (Enumeration e = DriverManager.getDrivers();e.hasMoreElements();){
	    gui.driverList.add(e.nextElement().getClass().getName());
	}
    }

    /**
     * w肳ꂽhCohCo̎̂擾B
     * @return hCo
     */
    private Driver getDriverFromName(String drvName){
        Driver drv = null;

	for (Enumeration e = DriverManager.getDrivers();e.hasMoreElements();){
	    drv = (Driver)e.nextElement();
	    if (drvName.equals(drv.getClass().getName()))
	        break;
	}

	return drv;
    }

    /**
     * hCỏ
     */
    public void deregisterDriver(){

        // XgIĂhCo擾
        Driver drv = getDriverFromName(gui.driverList.getSelectedItem());
	
	if (drv == null) return;

	try {
            // hCỏƃXg̍XV
	    DriverManager.deregisterDriver(drv);
	    updateDriverList();
	} catch (SQLException ex) {
            new MessageDialog("Could not deregister driver " + drv.toString(), gui);
	}
	
    }

    /**
     *
     */
    public void Quit() {
	gui.setVisible(false);
	gui.dispose();
	System.exit(0);
    }

    /**
     *
     */
    public void showStatementWindow() {
        app.getStatementFrame().setVisible(true);
    }

    /**
     *
     */
    public void showLogWindow() {
        app.getLogFrame().setVisible(true);
        DriverManager.setLogStream(app.getLogFrame().getLogStream());
    }

    /**
     *
     */
    public void showAddDriverDialog() {
        getApp().getAddDriverDialog().setVisible(true);
    }

    /**
     * f[^x[Xւ̐ڑ̊msB
     */
    public void Connect(){
	loginDialog.setVisible(true);
	Properties prop = loginDialog.getProp();

	Driver drv = null;

	try {
	    if (gui.driverChoiceTypeCheckboxGroup.getSelectedCheckbox() == gui.driverManagerCheckbox){
                // hCȏIhCoE}l[WɔCꍇ
	        conn = DriverManager.getConnection(gui.URLTextField.getText(), prop);
	    } else {
                // hCow肷ꍇ
                // IꂽhCo擾
	        drv = getDriverFromName(gui.driverList.getSelectedItem());
		if (drv == null) return;
                // hCoɒڎwĐڑs
		conn = drv.connect(gui.URLTextField.getText(), prop);
	    }
	    getApp().getStatementFrame().setConnection(conn);
	    getApp().getStatementFrame().setVisible(true);
	} catch (java.sql.SQLException ex) {
            new MessageDialog("State: " + ex.getSQLState()
                              + "Error code: "  + ex.getErrorCode(), gui);
	}
    }

}
