/*
 * Copyright (c) 1996 Nihon Sun Microsystems K.K.
 *
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

import java.awt.*;
import java.awt.event.*;

/**
 * JDBCTerminal OUT p[^ݒ_CAO
 * @version	%I% %E%
 * @author 	Yuichi Omata, Nihon Sun Microsystems K.K.
 */
public class OutParamDialog extends Dialog implements ActionListener, WindowListener {

    StatementFrame module;

    Label indexLabel;
    TextField indexField;
    Label SQLTypeLabel;
    Choice SQLTypeChoice;
    Button okButton;
    Button cancelButton;

    /**
     * RXgN^
     */
    public OutParamDialog(Frame parent, StatementFrame module) {
        super(parent);
        this.module = module;

        addWindowListener(this);
        setTitle("JDBCTerminal: Set OUT Parameter");
        
	GridBagLayout gbl = new GridBagLayout();
	gbl.columnWidths = new int[] {14,14,14,14};
	gbl.rowHeights =  new int[] {14,14,14,14,14,14,14};
	gbl.columnWeights = new double[] {0.0,0.0,0.0,0.0};
	gbl.rowWeights = new double[] {0.0,0.0,0.0,0.0,0.0,0.0,0.0};
	setLayout(gbl);
	GridBagConstraints gbc = new GridBagConstraints();

        //
        indexLabel = new Label("Index:");
        gbc.gridx = 1;
        gbc.gridy = 1;
        gbc.anchor = GridBagConstraints.EAST;
        gbl.setConstraints(indexLabel, gbc);
        add(indexLabel);

        //
        indexField = new TextField(2);
        gbc.gridx++;
        gbc.anchor = GridBagConstraints.WEST;
        gbl.setConstraints(indexField, gbc);
        add(indexField);
        
        //
        SQLTypeLabel = new Label("SQL Type:");
        gbc.gridx = 1;
        gbc.gridy += 2;
        gbc.anchor = GridBagConstraints.EAST;
        gbl.setConstraints(SQLTypeLabel, gbc);
        add(SQLTypeLabel);

        //
        SQLTypeChoice = new Choice();
        gbc.gridx++;
        gbc.anchor = GridBagConstraints.WEST;
        gbl.setConstraints(SQLTypeChoice, gbc);
        SQLTypeChoice.add("BIT");
        SQLTypeChoice.add("TINYINT");
        SQLTypeChoice.add("SMALLINT");
        SQLTypeChoice.add("INTEGER");
        SQLTypeChoice.add("BIGINT");
        SQLTypeChoice.add("FLOAT");
        SQLTypeChoice.add("REAL");
        SQLTypeChoice.add("DOUBLE");
        SQLTypeChoice.add("NUMERIC");
        SQLTypeChoice.add("DECIMAL");
        SQLTypeChoice.add("CHAR");
        SQLTypeChoice.add("VARCHAR");
        SQLTypeChoice.add("LONGVARCHAR");
        SQLTypeChoice.add("DATE");
        SQLTypeChoice.add("TIME");
        SQLTypeChoice.add("TIMESTAMP");
        SQLTypeChoice.add("BINARY");
        SQLTypeChoice.add("VARBINARY");
        SQLTypeChoice.add("LONGVARBINARY");
        SQLTypeChoice.select("CHAR");
        add(SQLTypeChoice);
        
        //
        okButton = new Button("OK");
        gbc.gridx = 1;
        gbc.gridy += 2;
        gbc.anchor = GridBagConstraints.CENTER;
        gbl.setConstraints(okButton, gbc);
        add(okButton);
        okButton.addActionListener(this);

        //
        cancelButton = new Button("Cancel");
        gbc.gridx++;
        gbl.setConstraints(cancelButton, gbc);
        add(cancelButton);
        cancelButton.addActionListener(this);

        pack();

    }

    /**
     * ANVECxgB
     * @param ev ANVECxg
     */
    public void actionPerformed(ActionEvent ev){
        if (okButton == ev.getSource())
	    module.addOutParam(indexField.getText(), SQLTypeChoice.getSelectedItem());
        setVisible(false);
    }

    /**
     * _CAOB
     * @param ev EBhEECxg
     */
    public void windowClosing(WindowEvent ev){
        setVisible(false);
    }

    public void windowClosed(WindowEvent ev) {}
    public void windowDeiconified(WindowEvent ev) {}
    public void windowIconified(WindowEvent ev) {}
    public void windowOpened(WindowEvent ev) {}


}
