/*
 * Copyright (c) 1996 Nihon Sun Microsystems K.K.
 *
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

import java.awt.*;
import java.awt.event.*;

/**
 * JDBCTerminal Xe[ggEt[ GUI
 * @version	%I% %E%
 * @author 	Yuichi Omata, Nihon Sun Microsystems K.K.
 */
public class StatementFrameGUI extends Frame {

    StatementFrame module;
    Label statementAreaLabel;
    TextArea statementArea;
    Label resultAreaLabel;
    TextArea resultArea;
    Button execButton;
    Panel statementTypePanel;
    Label statementLabel;
    CheckboxGroup statementTypeGroup;
    Checkbox statementCheckbox;
    Checkbox preparedCheckbox;
    Checkbox callableCheckbox;
    MenuBar menuBar;
    Menu paramMenu;
    MenuItem paramMenuSetIn;
    MenuItem paramMenuClearIn;
    MenuItem paramMenuSetOut;
    MenuItem paramMenuClearOut;
    MenuItem paramMenuInspect;

    /**
     * RXgN^
     * @param module Xe[ggEt[EW[
     */
    public StatementFrameGUI(StatementFrame module){
	this.module = module;
	addWindowListener(new StatementFrameCommand(0, module));
	setTitle("JDBCTerminal: Statement Window");

	GridBagLayout gbl = new GridBagLayout();
	gbl.columnWidths = new int[] {14,14,14,14,14};
	gbl.rowHeights =  new int[] {14,14,14,14,14,14,14,14};
	gbl.columnWeights = new double[] {0.0,0.0,0.0,0.0,0.0};
	gbl.rowWeights = new double[] {0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0};
	setLayout(gbl);
	GridBagConstraints gbc = new GridBagConstraints();
	
        // create statement area Label
        statementAreaLabel = new Label("Statement:");
        gbc.gridx = 1;
        gbc.gridy = 1;
        gbc.anchor = GridBagConstraints.WEST;
        gbl.setConstraints(statementAreaLabel, gbc);
        add(statementAreaLabel);

	// create statement TextArea
        statementArea = new TextArea("", 5, 50);
        gbc.gridy++;
	gbc.gridheight = 2;
	gbc.fill = GridBagConstraints.BOTH;
	gbl.setConstraints(statementArea, gbc);
	add(statementArea);

        // create result area Label
        resultAreaLabel = new Label("Result:");
        gbc.gridy += 2;
        gbc.gridheight = 1;
        gbc.fill = GridBagConstraints.NONE;
	gbl.setConstraints(resultAreaLabel, gbc);
	add(resultAreaLabel);

	// create result TextArea
        resultArea = new TextArea("", 20, 50);
	gbc.gridy++;
        gbc.fill = GridBagConstraints.BOTH;
	gbl.setConstraints(resultArea, gbc);
	add(resultArea);

	// create exec Button
	execButton = new Button("Exec");
	gbc.gridx = 3;
	gbc.gridy = 2;
        gbc.gridheight = 2;
	gbc.anchor = GridBagConstraints.CENTER;
	gbc.fill = GridBagConstraints.BOTH;
	gbl.setConstraints(execButton, gbc);
	execButton.addActionListener(new StatementFrameCommand(StatementFrameCommand.Exec, module));	
	add(execButton);

	// create statement type Panel
	statementTypePanel = new Panel();
	GridBagLayout stmttpGbl = new GridBagLayout();
	stmttpGbl.columnWidths = new int[] {14};
	stmttpGbl.rowHeights =  new int[] {14,14,14,14};
	stmttpGbl.columnWeights = new double[] {0.0};
	stmttpGbl.rowWeights = new double[] {0.0,0.0,0.0,0.0};
	statementTypePanel.setLayout(stmttpGbl);

	GridBagConstraints stmttpGbc = new GridBagConstraints();
	
	// create statement type Label
	statementLabel = new Label("Statement Type:");
	stmttpGbc.gridy = 0;
	stmttpGbc.anchor = GridBagConstraints.SOUTHWEST;
	stmttpGbl.setConstraints(statementLabel, stmttpGbc);
	statementTypePanel.add(statementLabel);

	// create checbox group
	statementTypeGroup = new CheckboxGroup();

	// create checkboxes
	statementCheckbox = new Checkbox("Statement", true, statementTypeGroup);
	stmttpGbc.gridy = 1;
	stmttpGbl.setConstraints(statementCheckbox, stmttpGbc);
	statementTypePanel.add(statementCheckbox);
        statementCheckbox.addItemListener(new StatementFrameCommand(0, module));

	preparedCheckbox = new Checkbox("Prepared", false, statementTypeGroup);
	stmttpGbc.gridy++;
	stmttpGbl.setConstraints(preparedCheckbox, stmttpGbc);
	statementTypePanel.add(preparedCheckbox);
        preparedCheckbox.addItemListener(new StatementFrameCommand(0, module));

	callableCheckbox = new Checkbox("Callable", false, statementTypeGroup);
	stmttpGbc.gridy++;
	stmttpGbl.setConstraints(callableCheckbox, stmttpGbc);
	statementTypePanel.add(callableCheckbox);
        callableCheckbox.addItemListener(new StatementFrameCommand(0, module));
	
        //
	gbc.gridy += 3;
        gbc.gridheight = 1;
	gbc.anchor = GridBagConstraints.NORTHWEST;
	gbc.fill = GridBagConstraints.NONE;
	gbl.setConstraints(statementTypePanel, gbc);
	add(statementTypePanel);

        // Add menus
	menuBar = new MenuBar();
	paramMenu = new Menu("Parameter");
        paramMenuSetIn = new MenuItem("set IN param");
        paramMenuSetOut = new MenuItem("set OUT param");
        paramMenuClearIn = new MenuItem("Clear all IN params");
        paramMenuClearOut = new MenuItem("Clear all OUT params");
        paramMenuInspect = new MenuItem("Inspect OUT params");
        paramMenu.add(paramMenuSetIn);
        paramMenu.add(paramMenuSetOut);
        paramMenu.add(paramMenuClearIn);
        paramMenu.add(paramMenuClearOut);
        paramMenu.add(paramMenuInspect);
        paramMenuSetIn.addActionListener(new StatementFrameCommand(StatementFrameCommand.SetIn, module));
        paramMenuSetOut.addActionListener(new StatementFrameCommand(StatementFrameCommand.SetOut, module));
        paramMenuClearIn.addActionListener(new StatementFrameCommand(StatementFrameCommand.ClearIn, module));
        paramMenuClearOut.addActionListener(new StatementFrameCommand(StatementFrameCommand.ClearOut, module));
        paramMenuInspect.addActionListener(new StatementFrameCommand(StatementFrameCommand.Inspect, module));

        menuBar.add(paramMenu);
        setMenuBar(menuBar);

        pack();
    }

}
