/*
 * Copyright (c) 1996 Nihon Sun Microsystems K.K.
 *
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

import java.servlet.*;
import java.servlet.html.*;
import java.io.*;
import java.net.*;
import java.sql.*;

/**
 * HelloJDBCServlet
 * 
 * hello e[uʂ HTML `ɂăuEUɕԂ
 * T[ubgB Jeeves Ɋ܂܂ DBServlet ɍ쐬ĂB
 * java.server pbP[W JDK1.0.2 ɊÂĂ邽߁AJeeves
 * 𓮍삳邽߂ɂ CLASSPATH  JDK1.0.2/lib/classes.zip 
 * ܂ޕKvB܂ Jeeves pbP[Wɂ java.sql pbP[W
 * ܂܂Ă̂ JDBC ̂̂̐ݒ͕KvȂAJDBC hCo
 * ͕̂ʓrCXg[āAݒ肵ĂKvB
 * ODBC ubWɎƁAubWWJfBNg
 *  ODBC_BRIDGE_HOME Ƃƈȉ̐ݒ肪KvłB
 * <pre>
 * Unix:
 *   ODBC ̃CXg[ƁA.odbc.ini t@C̍쐬
 *   gp DBMS ɑΉ ODBC hCo̓ƃCXg[
 *   CLASSPATH  $ODBC_BRIDGE_HOME/classes ǉ
 *   LD_LIBRARY_PATH  $ODBC_BRIDGE_HOME/sun/jdbc/odbc ǉ
 *   LD_LIBRARY_PATH  ODBC hCõCupXǉ
 *   ODBC_INI  .odbc.ini t@C PATH ǉ
 * 
 * Windows95, NT:
 *   gp DBMS ɑΉ ODBC hCo̓ƃCXg[
 *   ODBC ̃f[^\[X̐ݒ
 *   CLASSPATH  $ODBC_BRIDGE_HOME/classes ǉ
 * </pre>
 * ̃T[ubgRpCAJeeves ̐ݒʂŃT[ubg
 * ̓o^sKvB{ł helloJDBC ƂOœo^B
 * 
 * @author   Yuichi Omata, Nihon Sun Microsystems K.K.
 * @version	1.2 97/01/21
 */

public class HelloJDBCServlet extends GenericServlet {

    ServletStub stub;
    HtmlPage page;
    HtmlTable table;
    String myPath;
    String url, username, password;

    /**
     * init \bh
     */
    public void init(ServletStub stub) throws ServletException {
        this.stub = stub;
    }

    /**
     * service \bh
     */
    public void service(ServletRequest req, ServletResponse res) 
        throws ServletException, IOException
    {
               
	Connection con = null;
	PrintStream out = null;
            
        // HTML tH[̃p[^̎擾
        url = req.getParameter("url");
        username = req.getParameter("username");
        password = req.getParameter("password");
        myPath = "http://" + req.getServerName() + ":" + req.getServerPort();

        out = new PrintStream(res.getOutputStream());
        page = new HtmlPage("Data in hello table");
        page.wrap("center");
        page.add("Data in hello table", "h1");

        // tH[̃p[^sȏꍇ͏I
        if (url == null || username == null || password == null) {
            page.add("Invalid Parameters.");
            page.write(out);
            return;
        }

        try {
            // JDBC-ODBC ubW̓o^
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");

            // f[^x[Xڑ̊m
            con = DriverManager.getConnection(url, username, password);

            // ₢킹̎s
            Statement stmt = con.createStatement();
            ResultSet rs = stmt.executeQuery("SELECT * FROM hello");

            // o̓y[W̍쐬
            dispResultSet(rs);

            // hCotb^[Ƃĕt
            page.add("<hr>");
            page.add("ODBC Driver and Database Messages", "h3");
            checkForWarning(con.getWarnings());
            DatabaseMetaData dma = con.getMetaData();
            page.add("Connected to " + dma.getURL() + "<br>");
            page.add("Driver       " + dma.getDriverName() + "<br>");
            page.add("Version      " + dma.getDriverVersion() + "<br>");

            // ڑ̉
            rs.close();
            stmt.close();
            con.close();
        } catch (SQLException ex) {
            // O
            page.add("<hr>*** SQLException caught ***<p>");
            while (ex != null) {
                page.add("SQLState: " + ex.getSQLState() + "<br>");
                page.add("Message:  " + ex.getMessage() + "<br>");
                page.add("Vendor:   " + ex.getErrorCode() + "<br>");
                ex = ex.getNextException();
            }
        } catch (java.lang.Exception ex) {
            ex.printStackTrace();
        }

        // 쐬 HTML y[Wۂɏo
        page.write(out);
    }

    /**
     * T[ubg̏Ԃ
     */ 
    public String getServletInfo() {
	return "This is a servlet that shows hello Table";
    }

    /*
     * f[^x[X̌x𒲂ׂ
     */
    private void checkForWarning(SQLWarning warn)
          throws SQLException
    {
        boolean rc = false;
 
        if (warn != null) {
            page.add("<hr>*** Warning ***<p>");
            rc = true;
            while (warn != null) {
                page.add("SQLState: " + warn.getSQLState() + "<br>");
                page.add("Message:  " + warn.getMessage() + "<br>");
                page.add("Vendor:   " + warn.getErrorCode() + "<br>");
                warn = warn.getNextWarning();
          }
       }
    }

    /*
     * ₢킹ʂ HTML y[WƂč쐬
     */
    private void dispResultSet(ResultSet rs)
       throws SQLException, IOException
    {
        // HTML e[u̍쐬
        HtmlTable table = new HtmlTable("border=3");
        table.newRow();
 
        // ^Ef[^păwb_[쐬
        ResultSetMetaData rsmd = rs.getMetaData();
        int numCols = rsmd.getColumnCount();

        for (int i=1; i<=numCols; i++) {
            table.addHeader(rsmd.getColumnLabel(i));
        }

        // esf[^̏o
        while (rs.next()) {
            // e[ủs
            table.newRow();

            String name = rs.getString("name");
            table.addData(name);
            table.addData(rs.getString("age"));
            table.addData(rs.getDate("birth_date").toString());
            table.addData(rs.getString("comment"));

            // face tB[h̓e[uɒډ摜t@C𖄂ߍނ
            // ł͂Ȃ getImage T[ubgֈϑBۂɂ
            // <img src="http://xxx.xxx.xxx.xxx:8080/getImage?name=xxx>"
            // Ƃ񂪍쐬Ae[uɖߍ܂B
            String queryString = "?name=" + name.trim();
            table.addHeader("<img src=\"" + myPath + "/getImage" 
                                                + queryString + "\">");
       }
        page.add(table);
    }

    /**
     * T[ubgpȌo̓\bh
     */
    public void log(String message) {
        stub.getServletContext().log(this, message);
    }

}
