import java.awt.Frame;
import java.awt.Button;
import java.awt.TextField;
import java.awt.FlowLayout;
import java.awt.AWTEvent;
import java.awt.event.WindowEvent;

public class ViewSample extends Frame {
    ControllerSample controller;
    TextField inputField;
    TextField outputField;
    Button copyButton;

    public ViewSample() {
        // GUI 
        inputField = new TextField(10);
        outputField = new TextField(10);
        outputField.setEditable(false);
        copyButton = new Button("==>");
        // GUI 
        setLayout(new FlowLayout());
        add(inputField);
        add(copyButton);
        add(outputField);
        pack();
        // listener Ͽ
        controller = new ControllerSample(this);
        copyButton.addActionListener(controller);
        // 
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    }

    public void copyText() {
        String text;
        text = inputField.getText();
        if (text == null)
            text = "";
        outputField.setText(text);
    }

    protected void processWindowEvent(WindowEvent ev) {
        switch (ev.getID()) {
        case WindowEvent.WINDOW_CLOSING:
            this.dispose();
            this.setVisible(false);
            break;
        case WindowEvent.WINDOW_CLOSED:
            // ץꥱνλ
            System.exit(0);
        }
    }

    public static void main(String[] args) {
        ViewSample vs;
        vs = new ViewSample();
        vs.setVisible(true);
    }
}
