/*
 * Copyright (c) 1996 Nihon Sun Microsystems K.K.
 *
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

package COM.Sun.Japan.yjs.mwt;

import java.awt.*;
import java.io.*;

/**
 * Oo͗peLXgEGAB
 * JDK 1.1 ɊÂč쐬Ă邪AJDBC 1.1001c ̃o[Wł
 * DriverManager.setLogStream(PrintStream) ƂȂĂ邽߂ɁAʂ
 * Ȍo͂̌Ƃ PrintStream Ԃ悤ɂȂĂB
 *  Reader gpĂ邽߂ɁAo͂邱ƂłB
 *
 * @version	%I% %E%
 * @author 	Yuichi Omata, Nihon Sun Microsystems K.K.
 */
public class LogTextArea extends TextArea implements Runnable {

    private ByteToCharConverter btc;
    private PipedInputStream pin;
    
    /**
     * Oo͗p̃eLXgGA𐶐B
     */
    public LogTextArea() {
	this("", 0, 0, SCROLLBARS_BOTH, ByteToCharConverter.getDefault());
    }

    /**
     * Oo͗p̃eLXgGA𐶐A^ꂽeLXg\B
     * @param text \eLXg
     */
    public LogTextArea(String text) {
	this(text, 0, 0, SCROLLBARS_BOTH, ByteToCharConverter.getDefault());
    }

    /**
     * w肳ꂽ傫̍sƗOo͗p̃eLXgGA𐶐
     * ^ꂽeLXg\B
     * @param text \eLXg
     * @param rows s
     * @param columns 
     */
    public LogTextArea(String text, int rows, int columns) {
        this(text, rows, columns, SCROLLBARS_BOTH, ByteToCharConverter.getDefault());
    }

    /**
     * w肳ꂽ傫̍sƗOo͗p̃eLXgGA𐶐
     * w肳ꂽXN[o[ƃeLXg\B
     * @param text \eLXg
     * @param rows s
     * @param columns 
     * @param scrollbars \XN[o[̎
     */
    public LogTextArea(String text, int rows, int columns, int scrollbars) {
	this(text, rows, columns, scrollbars, ByteToCharConverter.getDefault());
    }

    /**
     * w肳ꂽ傫̍sƗOo͗p̃eLXgGA𐶐
     * w肳ꂽXN[o[ƃeLXg\BȌo͂ɂ͎w肳ꂽ
     * ̃GR[fBOɍ킹R[hϊsB
     * @param text \eLXg
     * @param rows s
     * @param columns 
     * @param scrollbars \XN[o[̎
     * @param enc gpGR[fBO
     */
    public LogTextArea(String text, int rows, int columns, int scrollbars, String enc) 
	throws UnsupportedEncodingException 
    {
	this(text, rows, columns, scrollbars, ByteToCharConverter.getConverter(enc));
    }

    /**
     * w肳ꂽ傫̍sƗOo͗p̃eLXgGA𐶐
     * w肳ꂽXN[o[ƃeLXg\BȌo͂ɂ͎w肳ꂽ
     * ByteToCharConverter gpB
     * @param text \eLXg
     * @param rows s
     * @param columns 
     * @param scrollbars \XN[o[̎
     * @param btc gpByteToCharConverter
     */
    public LogTextArea(String text, int rows, int columns, int scrollbars, ByteToCharConverter btc) {
	super(text, rows, columns, scrollbars);
	this.btc = btc;
        pin = new PipedInputStream();
        Thread thread = new Thread(this);
        thread.start();
    }

    /**
     *
     */
    public void run() {
        BufferedReader br = new BufferedReader(new InputStreamReader(pin, btc));
        String text;

	try {
            while ((text = br.readLine()) != null){
                append(text + "\n");
            }
        } catch (IOException ex){}
    }
	
    /**
     * Oo͗p̃Xg[𓾂B
     * @return Oo͗p̃Xg[
     */    
    public PrintStream getLogStream() throws IOException {
        return new PrintStream(new PipedOutputStream(pin));
    }
}
