/*
 * Copyright (c) 1996 by Nihon Sun Microsystems K.K.
 *
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

package COM.Sun.Japan.yjs.mwt;

import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;

/**
 * gOXCb`E^Cṽ{^BꂽԁAオĂ
 * Ԃ 2 ̏ԂB
 *
 * @version     1.5 97/01/11
 * @author      Tadayoshi Maekawa, Nihon Sun Microsystems K.K.
 */
public class SwitchButton extends Canvas implements MouseListener {
    /**
     * {^́u/ʁvԂ\킷BԂ̂Ƃɂ trueAʏԂ̂
     * ɂ falseB
     * @see #getStatus
     */
    boolean status;

    /** 
     * {^̃xB
     * @see #setLabel
     */
    String label;

    /**
     * {^̕B
     * @see #height
     */
    int width;

    /**
     * {^̍B
     * @see #width
     */
    int height;

    /**
     * ŏB{^`̓sAKvB
     */
    static int minWidth = 10;

    /**
     * ŏB{^`̓sAKvB
     */
    static int minHeight = 10;

    /**
     * {^̖AÕ̕B
     */
    int border;

    /**
     * }[WB{^`掞ɎgpB
     */
    int margin = 2;

    /**
     * obNOEhEJ[B
     * @see #foreground
     */
    Color background = null;

    /**
     * tHAOEhEJ[B
     * @see #background
     */
    Color foreground = null;

    /**
     * {^Ex̃tHgB
     */
    Font font = null;

    /**
     * /s\킷tOB
     */
    boolean operatable;

    /**
     * action listener ܂ action listener ̃Xg(EventListenerList)B
     */
    protected ActionListener actionListener;

    /**
     * ftHgERXgN^B
     */
    public SwitchButton() {
        this("");
    }

    /**
     * {^ExɎRXgN^B
     * @param label {^ExB
     */
    public SwitchButton(String label) {
        setLabel(label);
        operatable = true;
        status = false;
        border = 2;
        font = null;
        addMouseListener(this);
    }

    /**
     * pl add ꂽɁA{^̃TCY肷BTCÝA
     * x̕񂩂vZB
     */
    public synchronized void addNotify() {
        fitButton();
        super.addNotify();
    }

    /**
     * {^̕`B
     * @param g `Ɏgp GraphicsB
     */
    public void paint(Graphics g) {
        Rectangle rect = getBounds();
        FontMetrics fm = g.getFontMetrics();
        int lx = rect.width/2 - fm.stringWidth(label)/2;
        int ly = rect.height/2 + fm.getHeight()/2 - margin -1;
        int i, n, w, e, s;
        Color bg, buttonColor;
        ToolColor tc = new ToolColor();

        // visible łȂȂ΁AeReĩobNOEhEJ[
        // œhׂB
        Component parent = getParent();
        bg = (parent != null) ? (parent.getBackground()) : (getBackground());
        if (!isVisible()) {
            g.setColor(bg);
            g.fillRect(0, 0, rect.width, rect.height);
            return;
        }
        // `Jn
        tc.setBase(getBackground());
        // first step : {^ŜhׂB
        buttonColor = status ? tc.pushed() : tc.base();
        g.setColor(buttonColor);
        g.fillRect(margin + border, margin + border,
                   rect.width - 2 * margin - 2 * border,
                   rect.height - 2 * margin - 2 * border);
        // second step : xB
        g.setColor(getForeground());
        g.drawString(label, lx, ly);
        // third step : disable Ȃ}XNB
        if (!isEnabled()) {
            int x = lx + fm.stringWidth(label);
            int y = ly - fm.getHeight();
            g.setColor(buttonColor);
            for (i = y; i <= ly; i += 3)
                g.drawLine(lx, i, x, i);
            for (i = lx; i <= x; i += 3)
                g.drawLine(i, ly, i, y);
        }
        // fourth step : ]hB
        g.setColor(bg);
        g.fillRect(0, 0, rect.width, margin);
        g.fillRect(0, 0, margin, rect.height);
        g.fillRect(0, rect.height - margin, rect.width, margin);
        g.fillRect(rect.width - margin, 0, margin, rect.height);
        // fifth step : B
        g.setColor(tc.highlight());
        if (status) {
            g.fillRect(margin, rect.height - margin-border,
                       rect.width - 2 * margin, border);
            g.fillRect(rect.width - margin - border, margin,
                       border, rect.height - 2 * margin);
        } else {
            g.fillRect(margin, margin, rect.width - 2 * margin, border);
            g.fillRect(margin, margin, border, rect.height - 2 * margin);
        }
        // sixth step : ÕB
        n = w = margin;
        e = rect.width - margin - border + 1;
        s = rect.height - margin - border + 1;
        g.setColor(tc.shadow());
        if (status) {
            for (i = 0; i < border; i++) {
                g.drawLine(w, n+i, e-i, n+i);
                g.drawLine(w+i, n, w+ i, s-i);
            }
        } else {
            for (i = 0; i < border; i++) {
                g.drawLine(w+i, s-i, e, s-i);
                g.drawLine(e-i, n+i, e-i, s);
            }
        }
    }

    /**
     * {^̃TCYԂB
     * @see #resize
     */
    public Dimension getSize() {
        return new Dimension(width, height);
    }

    /**
     * Dimennsion Ɏ胊TCYB
     * @param d V Dimension
     */
    public void setSize(Dimension d) {
        setSize(d.width, d.height);
    }

    /**
     * ƍ̒lɎ胊TCYB
     * @param w V
     * @param h V
     */
    public synchronized void setSize(int w, int h) {
        width = Math.max(w, minWidth);
        height = Math.max(h, minHeight);
        super.setSize(width, height);
    }

    /**
     * œK(ŏ)ȑ傫ԂB
     */
    public Dimension getPreferredSize() {
        Dimension d;
        FontMetrics fm;
        Graphics g = getGraphics();
        if ((g = getGraphics()) != null &&
            (fm = g.getFontMetrics()) != null &&
            label != null && label.length() > 0) {
            d = new Dimension(fm.stringWidth(label) + (margin + border) * 2,
                              fm.getHeight() + (margin + border) * 2);
        } else {
            d = new Dimension(minWidth, minHeight);
        }
        return d;
    }

    /**
     * {^Ex̃ZbgB
     * @param label {^̃x
     */
    public void setLabel(String label) {
        this.label = label;
        repaint();
    }

    /**
     * {^ExԂB
     * @see #setLabel
     */
    public String getLabel() {
        return label;
    }

    /**
     *  SwitchButton ŔANVECxg󂯂
     * action listener ǉB
     * @param l action listner
     */
    public void addActionListener(ActionListener l) {
        actionListener = EventListenerList.add(actionListener, l);
        newEventsOnly = true;
    }

    /**
     *  SwitchButton ŔANVECxg󂯂Ă
     * action listener OB
     * @param l action listner
     */
    public void removeActionListener(ActionListener l) {
        actionListener = EventListenerList.remove(actionListener, l);
    }

    /**
     * MOUSE_PRESSED Cxg̏BACTION_PERFORMED ɕςB
     * @param ev Cxg
     */
    public void mousePressed(MouseEvent ev) {
        int x = ev.getX();
        int y = ev.getY();
        Rectangle rect = getBounds();
        if (x < margin || x > rect.width - margin ||
            y < margin || y > rect.height - margin)
            return;
        // changes to action event
        ActionEvent aev;
        aev = new ActionEvent(this, ActionEvent.ACTION_PERFORMED, getLabel());
        this.processActionEvent(aev);
    }

    /**
     * MOUSE_RELEASED CxgLZB
     * @param ev Cxg
     */
    public void mouseReleased(MouseEvent ev) {}

    /**
     * MOUSE_ENTERED CxgLZB
     * @param ev Cxg
     */
    public void mouseEntered(MouseEvent ev) {}

    /**
     * MOUSE_EXITED CxgLZB
     * @param ev Cxg
     */
    public void mouseExited(MouseEvent ev) {}
    /**
     * MOUSE_CLICKED CxgLZB
     * @param ev Cxg
     */
    public void mouseClicked(MouseEvent ev) {}

    /**
     * action Cxg̏sB
     * @param ev action Cxg
     */
    protected void processActionEvent(ActionEvent ev) { 
        if (!operatable)
            return;
        status = !status;
        repaint();
        if (actionListener != null) {
            actionListener.actionPerformed(ev);
        }
    }

    /**
     * {^̉/ʏԂZbgB
     * @param s V/ʏ
     */
    public synchronized void setStatus(boolean s) {
        status = s;
        repaint();
    }

    /**
     * ݂̃{^̉/ʏԂԂB
     * @return ԂȂ trueAʏԂȂ false ԂB
     */
    public boolean getStatus() {
        return status;
    }

    /**
     * tHAOEhEJ[̃ZbgB
     * @param f VtHAOEhEJ[
     * @see #getForeground
     */
    public synchronized void setForeground(Color f) {
        foreground = f;
        super.setForeground(f);
    }

    /**
     * obNOEhEJ[̃ZbgB
     * @param b VobNOEhEJ[
     * @see #getBackground
     */
    public synchronized void setBackground(Color b) {
        background = b;
        super.setBackground(b);
    }

    /**
     * tHAOEhEJ[ԂB
     * @see #setForeground
     */
    public Color getForeground() {
        if (foreground != null)
            return foreground;
        return super.getForeground();
    }

    /**
     * obNOEhEJ[ԂB
     * @see #setBackground
     */
    public Color getBackground() {
        if (background != null)
            return background;
        return super.getBackground();
    }

    /**
     * tHg̃ZbgB
     * @param f VtHg
     * @see #getFont
     */
    public synchronized void setFont(Font f) {
        font = f;
        super.setFont(f);
    }

    /**
     * ݂̃tHgԂB
     * @see #setFont
     */
    public Font getFont() {
        if (font != null)
            return font;
        return super.getFont();
    }

    /**
     * /s\킷tOԂB
     * @see #setOperatable
     * @return Ȃ trueAsȂ false
     */
    public boolean isOperatable() {
        return operatable;
    }

    /**
     * /s̃tOZbgB
     * @param f /s̃tO
     * @see #isOperatable
     */
    public synchronized void setOperatable(boolean f) {
        operatable = f;
    }

    /**
     * {^ANeBu/ANeBuɂB
     * @param f tO
     */
    public synchronized void setEnabled(boolean f) {
        super.setEnabled(f);
        repaint();
    }

    /**
     * Tab  Shift-Tab 󂯂邩Hł͋ĂB
     */
    public boolean isForcusTraversable() {
        return true;
    }

    /**
     * SwitchButton \킷ԂB
     */
    protected String  paramString() {
        return super.paramString() + ",label=" + label;
    }

    /**
     * eReiɃCAEgB{^̃TCYςꍇ
     * Ă΂B
     */
    protected void flushParentLayout() {
        Container parent = getParent();
        if (parent != null)
            parent.doLayout();
    }

    /**
     * {^̃TCYAx̑傫ɍ킹B
     */
    protected void fitButton() {
        FontMetrics fm;
        Font f;
        int wl;
        int w, h;

        f = getFont();
        if (f == null) {
            Graphics  g = getGraphics();
            f = (g != null) ? (g.getFont()) : null;
        }
        
        if (f == null)
            return; // cannot fit

        fm = getFontMetrics(f);
        wl = (label == null) ? 0 : (fm.stringWidth(label));
        w = Math.max(wl, getPreferredSize().width);
        w += fm.charWidth('W') * 2;
        h = fm.getHeight() + border * 2 + margin * 2;
        width = Math.max(w, width);
        height = Math.max(h, height);
    }
}
