/*
 * Copyright (c) 1996 by Tadayoshi Maekawa, Nihon Sun Microsystems K.K.
 *
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

package  COM.Sun.Japan.yjs.mwt;

import  java.awt.Color;

/**
 * {^̗ GUI ̖Õ̐FvZNXB
 * 
 * @version     1.2 97/01/08
 * @author      Tadayoshi Maekawa, Nihon Sun Microsystems K.K.
 */
public final class ToolColor  {
    /**
     * AÕ̌vZɗpp[^̐ݒB
     */
    private static final double PUSHED = 0.85;
    private static final double HIGHLIGHT = 1 / 0.85;
    private static final double SHADOW = 0.55;
    private static final int BIAS = 130;  // for highlight part

    /**
     * FB̐FɖAÕ̐F̌vZsB
     */
    private Color base;

    /**
     * ftHgERXgN^B
     */
    public ToolColor() {
        this(null);
    }

    /**
     * FƂȂ Color IuWFNgɎRXgN^B
     * @param c F
     */
    public ToolColor(Color c) {
        setBase(c);
    }

    /**
     * FZbgB
     * @param c VF
     */
    public void setBase(Color c) {
        base = c;
    }

    /**
     * ̐FɑΉ Color IuWFNgԂB
     */
    public Color highlight() {
        if (base == null) {
            return Color.white;
        }
        return highlight(base);
    }

    /**
     * ̐FvZA̐FɑΉ Color IuWFNg
     * ԂB
     * @param c ̐F
     */
    public static Color highlight(Color c) {
        int red, green, blue;
        red = Math.min((int)(c.getRed() * HIGHLIGHT), 255);
        green = Math.min((int)(c.getGreen() * HIGHLIGHT), 255);
        blue = Math.min((int)(c.getBlue() * HIGHLIGHT), 255);
        if (red == 0 || green == 0 || blue == 0) {
            red = Math.min(red + BIAS, 255);
            green = Math.min(green + BIAS, 255);
            blue = Math.min(blue + BIAS, 255);
        }
        return new Color(red, green, blue);
    }
    
    /**
     * Õ̐FɑΉ Color IuWFNgԂB
     */
    public Color shadow() {
        if (base == null) {
            return Color.black;
        }
        return shadow(base);
    }

    /**
     * ̐FvZAÕ̐FɑΉ Color IuWFNg
     * ԂB
     * @param c ̐F
     */
    public static Color shadow(Color c) {
        int red, green, blue;
        red = Math.max((int)(c.getRed() * SHADOW), 0);
        green = Math.max((int)(c.getGreen() * SHADOW), 0);
        blue = Math.max((int)(c.getBlue() * SHADOW), 0);
        return new Color(red, green, blue);
    }
    
    /**
     * ̐FԂB
     */
    public Color pushed() {
        if (base == null)
            return Color.black;
        return pushed(base);
    }

    /**
     * ̐FvZA̐FԂB
     * @param c ̐F
     */
    public static Color pushed(Color c) {
        int red, green, blue;
        red = Math.max((int)(c.getRed() * PUSHED), 0);
        green = Math.max((int)(c.getGreen() * PUSHED), 0);
        blue = Math.max((int)(c.getBlue() * PUSHED), 0);
        return new Color(red, green, blue);
    }

    /**
     * ݂̊FԂB
     */
    public Color base() {
        return base;
    }
}
